diff -ruN freeswan-1.9.orig/utils/fswcert-0.4/fswcert.c freeswan-1.9/utils/fswcert-0.4/fswcert.c
--- freeswan-1.9.orig/utils/fswcert-0.4/fswcert.c	Wed Dec 31 19:00:00 1969
+++ freeswan-1.9/utils/fswcert-0.4/fswcert.c	Wed May 16 11:20:34 2001
@@ -0,0 +1,550 @@
+/* Certificate and Private Key Format Conversions for FreeS/WAN
+ *
+ * Copyright (C) 2000 Andreas Gruenbacher, <a.gruenbacher@computer.org>
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+ * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * for more details.
+ */
+
+#include <stdio.h>
+#include <stdarg.h>
+#include <string.h>
+#include <unistd.h>
+
+#define _GNU_SOURCE
+#include <getopt.h>
+
+#include <termio.h>
+
+#include <openssl/crypto.h>
+#include <openssl/buffer.h>
+#include <openssl/bio.h>
+#include <openssl/err.h>
+#include <openssl/pkcs12.h>
+#include <openssl/pem.h>
+#include <openssl/rsa.h>
+
+struct option long_options[] = {
+	{"certificate",   0, 0, 'c'},
+	{"key",           0, 0, 'k'},
+	{"left",          0, 0, 'l'},
+	{"right",         0, 0, 'r'},
+	{"type",          1, 0,  1 },
+	{"format",        1, 0,  2 },
+	{"quiet",         0, 0, 'q'},
+	{"der-output",    0, 0, 'd'},
+	{"directory",     1, 0, 'C'},
+	{"version",       0, 0, 'v'},
+	{"help",          0, 0, 'h'},
+	{NULL,            0, 0,  0 }
+};
+
+int prompt_for_passwords = 0;
+const char *peer_prefix = NULL;
+int opt_quiet = 0;
+int der_output = 0;
+int der_binary = 0;
+const char *input_file = NULL;
+
+#define DUMP_CERTIFICATE	1
+#define DUMP_KEY		2
+int opt_what = 0;
+
+BIO *bio_err = NULL;
+
+enum input_file_type { IN_PKCS12 = 1, IN_X509 = 2, IN_RSA = 3 };
+enum input_format { FORMAT_ASN1 = 1, FORMAT_PEM = 3 };
+
+void print_errors(int ssl, const char *fmt, ...)
+{
+	if (fmt) {
+		va_list args;
+	
+		va_start(args, fmt);
+		if (input_file)
+			fprintf(stderr, "%s: ", input_file);
+		fprintf(stderr, "Error ");
+		vfprintf(stderr, fmt, args);
+		fprintf(stderr, "\n");
+		va_end(args);
+	}
+	if (ssl && !opt_quiet)
+		ERR_print_errors(bio_err);
+}
+
+const char *read_password(void)
+{
+	static char password[1024];
+	struct termio saved, no_echo;
+
+	printf("Password: ");
+
+	(void) ioctl(0, TCGETA, &saved);
+	no_echo = saved;
+	no_echo.c_lflag &= ~ECHO;
+	(void) ioctl(0, TCSETA, &no_echo);
+	fgets(password, sizeof(password), stdin);
+	(void) ioctl(0, TCSETA, &saved);
+	puts("");
+
+	if (strchr(password, '\n'))
+		*strchr(password, '\n') = '\0';
+	return password;
+}
+
+void BN_print_0(BIGNUM *num)
+{
+	int bits = BN_num_bits(num);
+
+	if ((bits-1) % 8 < 3)
+		putchar('0');
+	BN_print_fp(stdout, num);
+}
+
+#define print(what, num) do { \
+	printf("\t%s: 0x", what); \
+	BN_print_0(num); \
+	putchar('\n'); \
+	} while(0)
+
+int dump_rsa_private_key(RSA *rsa)
+{
+	if (rsa->d == NULL) {
+		print_errors(0, "no private exponent");
+		return 1;
+	}
+	if (opt_what & DUMP_KEY) {
+		print("Modulus", rsa->n);
+		print("PublicExponent", rsa->e);
+		print("PrivateExponent", rsa->d);
+		print("Prime1", rsa->p);
+		print("Prime2", rsa->q);
+		print("Exponent1", rsa->dmp1);
+		print("Exponent2", rsa->dmq1);
+		print("Coefficient", rsa->iqmp);
+	}
+	return 0;
+}
+
+#undef print
+
+int dump_x509_certificate(X509 *x509)
+{
+	BUF_MEM *subject;
+	EVP_PKEY *pkey;
+	RSA *rsa;
+	int i, error = 0;
+	char derbuf[256];
+	
+	if (!x509->cert_info || !x509->cert_info->subject ||
+            !x509->cert_info->subject->bytes) {
+		fprintf(stderr, "Certificate contains no subject\n");
+		return 1;
+	}
+	subject = &x509->cert_info->subject->bytes[0];
+
+	if (opt_what & DUMP_CERTIFICATE) {
+		if (!der_output) {
+			printf("\t%sid=@~", peer_prefix);
+			for (i = 0; i < subject->length; i++)
+				printf("%02X", (unsigned char)subject->data[i]);
+			printf("\n");
+		} else if (der_output) {
+			int derlen;
+			unsigned char *derbytes, *derout;
+
+			derlen=i2d_X509_NAME(x509->cert_info->subject, NULL);
+			derbytes=malloc(derlen);
+			derout=(unsigned char *)derbytes;
+
+			derlen=i2d_X509_NAME(X509_get_subject_name(x509), &derout);
+			derout=(unsigned char *)derbytes;
+
+			if (der_binary) {
+				for (i = 0; i < derlen; i++)
+					printf("%c", derout[i]);
+			} else {
+				X509_NAME_oneline(x509->cert_info->subject,
+					derbuf, 256);
+				printf("\t#%s DN: %s\n", peer_prefix, derbuf);
+				printf("\t%sid=@~", peer_prefix);
+				for (i = 0; i < derlen; i++)
+					printf("%02X", (unsigned char)derout[i]);
+				printf("\n");
+
+#if 0
+{ /* DEBUGGING ON */
+  X509_NAME *xn = X509_NAME_new();
+  char dnout[256];
+  if (xn == NULL) {
+    printf("\t#Unable to malloc X509_NAME *xn");
+  }
+
+  printf("\t#derlen = %d\n", derlen);
+  printf("\t#certlen = %d\n", certlen);
+
+  /* X509_NAME * d2i_X509_NAME(X509_NAME **a,unsigned char **pp,long length); 
+   */
+  xn = d2i_X509_NAME(&xn, &(derout), (long)derlen);
+
+  if (xn != NULL) {
+    X509_NAME_oneline(xn,dnout,256);
+    printf("\t#DNtest == %s\n", dnout);
+  } else {
+    printf("\t#Invalid DER string\n");
+  }
+} /* DEBUGGING OFF */
+#endif
+
+			}
+
+			free(derbytes);
+		}
+	}
+
+	pkey = X509_get_pubkey(x509);
+	if (pkey == NULL) {
+		print_errors(1, "getting public key");
+		return 1;
+	}
+	if (pkey->type != EVP_PKEY_RSA) {
+		print_errors(0, "not an RSA public key");
+		error = 1;
+		goto cleanup;
+	}
+	rsa = pkey->pkey.rsa;
+	
+#if 0
+	if (opt_what & DUMP_CERTIFICATE) {
+		int bytes = BN_num_bytes(rsa->e);
+		printf("\t%srsasigkey=0x%02X", peer_prefix, bytes);
+		BN_print_0(rsa->e);
+		BN_print_0(rsa->n);
+		putchar('\n');
+	}
+#endif
+
+cleanup:
+	EVP_PKEY_free(pkey);
+	return 0;
+}
+
+int read_pkcs12_safebag(PKCS12_SAFEBAG *bag, const char *password)
+{
+	PKCS8_PRIV_KEY_INFO *p8;
+	EVP_PKEY *pkey;
+	X509 *x509;
+	RSA *rsa;
+	int error = 0;
+	
+	switch (M_PKCS12_bag_type(bag)) {
+		case NID_keyBag:
+			p8 = bag->value.keybag;
+			pkey = EVP_PKCS82PKEY(p8);
+			if (!pkey) {
+				print_errors(1, "grabbing private key");
+				return 1;
+			}
+			rsa = EVP_PKEY_get1_RSA(pkey);
+			EVP_PKEY_free(pkey);
+			if (!rsa) {
+				print_errors(1, "getting RSA key");
+				return 1;
+			}
+			error = dump_rsa_private_key(rsa);
+			RSA_free(rsa);
+			break;
+
+		case NID_pkcs8ShroudedKeyBag:
+			p8 = M_PKCS12_decrypt_skey(bag, password, -1);
+			if (!p8) {
+				print_errors(1, "decrypting private key");
+				return 1;
+			}
+			pkey = EVP_PKCS82PKEY(p8);
+			PKCS8_PRIV_KEY_INFO_free(p8);
+			if (!pkey) {
+				print_errors(1, "grabbing private key");
+				return 1;
+			}
+			rsa = EVP_PKEY_get1_RSA(pkey);
+			EVP_PKEY_free(pkey);
+			if (!rsa) {
+				print_errors(1, "getting RSA private key");
+				return 1;
+			}
+			error = dump_rsa_private_key(rsa);
+			RSA_free(rsa);
+			break;
+
+		case NID_certBag:
+			if (M_PKCS12_cert_bag_type(bag) != NID_x509Certificate){
+				print_errors(0, "not an X.509 certificate");
+				return 1;
+			}
+			/* only dump the key's certificate */
+			if (!PKCS12_get_attr(bag, NID_localKeyID))
+				return 0;
+			x509 = M_PKCS12_certbag2x509(bag);
+			if (!x509) {
+				print_errors(1, "grabbing certificate");
+				return 1;
+			}
+			if (dump_x509_certificate(x509))
+				return 1;
+			X509_free(x509);
+			break;
+
+		default:
+			/* other bag entry */
+	}
+	return error;
+}
+
+int read_pkcs12_file(BIO *bio_in)
+{
+	const char *password = "\0";
+	PKCS12 *p12;
+	STACK /* _OF(PKCS7) */ *asafes = NULL;
+	PKCS7 *p7;
+	int i;
+
+	p12 = d2i_PKCS12_bio (bio_in, NULL);
+	if (!p12) {
+		print_errors(1, "reading PKCS12 file");
+		return 1;
+	}
+	if (!PKCS12_verify_mac(p12, password, 0)) {
+		if (prompt_for_passwords)
+			password = read_password();
+		if (!prompt_for_passwords ||
+		    !PKCS12_verify_mac(p12, password, -1)) {
+			print_errors(1, "verifying MAC: wrong password?");
+			return 1;
+		}
+	}
+
+	/* Unpack PKCS12 file */
+	asafes = M_PKCS12_unpack_authsafes (p12);
+	if (!asafes) {
+		print_errors(1, "unpacking PKCS12 file");
+		return 1;
+	}
+	for (i = 0; i < sk_num(asafes); i++) {
+		int bagnid, j;
+		STACK /* _OK(PKCS12) */ *bags;
+
+		p7 = (PKCS7 *) sk_value(asafes, i);
+		bagnid = OBJ_obj2nid(p7->type);
+		if (bagnid == NID_pkcs7_data)
+			bags = M_PKCS12_unpack_p7data(p7);
+		else if (bagnid == NID_pkcs7_encrypted)
+			bags = M_PKCS12_unpack_p7encdata(p7, password, -1);
+		else
+			continue;
+		if (!bags) {
+			print_errors(1, "unpacking PKCS12 file");
+			return 1;
+		}
+		for (j = 0; j < sk_num(bags); j++) {
+			PKCS12_SAFEBAG *bag =
+				(PKCS12_SAFEBAG *)sk_value(bags, j);
+			if (read_pkcs12_safebag(bag, password))
+				return 1;
+		}
+		sk_pop_free(bags, PKCS12_SAFEBAG_free);
+	}
+	sk_pop_free(asafes, PKCS7_free);
+	return 0;
+}
+
+int read_x509_file(BIO *bio_in, enum input_format input_format)
+{
+	X509 *x509 = NULL;
+	int error;
+
+	if (input_format == FORMAT_PEM)
+		x509 = PEM_read_bio_X509(bio_in, NULL, NULL, NULL);
+	else if (input_format == FORMAT_ASN1)
+		x509 = d2i_X509_bio(bio_in, NULL);
+	if (!x509) {
+		print_errors(1, "reading X509 certificate");
+		return 1;
+	}
+	error = dump_x509_certificate(x509);
+	X509_free(x509);
+
+	return error;
+}
+
+int read_rsa_file(BIO *bio_in, enum input_format input_format)
+{
+	RSA *rsa = NULL;
+	int error;
+
+	if (input_format == FORMAT_PEM)
+		rsa = PEM_read_bio_RSAPrivateKey(bio_in, NULL, NULL, NULL);
+	else if (input_format == FORMAT_ASN1)
+		rsa = d2i_RSAPrivateKey_bio(bio_in, NULL);
+	if (!rsa) {
+                print_errors(1, "reading RSA private key");
+                return 1;
+        }
+	error = dump_rsa_private_key(rsa);
+	RSA_free(rsa);
+	return error;
+}
+
+int main(int argc, char *argv[])
+{
+	enum input_file_type input_file_type = 0;
+	enum input_format input_format = 0;
+	int error = 0, opt;
+
+	prompt_for_passwords = isatty(0) && isatty(1);
+
+	while ((opt = getopt_long(argc, argv, "cklrqd:C:hv",
+	                          long_options, NULL)) != -1) {
+		switch(opt) {
+			case 1:  /* input file type */
+				if (!strcmp(optarg, "pkcs12"))
+					input_file_type = IN_PKCS12;
+				else if (!strcmp(optarg, "x509"))
+					input_file_type = IN_X509;
+				else if (!strcmp(optarg, "rsa"))
+					input_file_type = IN_RSA;
+				else
+					goto synopsis;
+				break;
+
+			case 2:  /* input format */
+				if (!strcmp(optarg, "PEM"))
+					input_format = FORMAT_PEM;
+				else if (!strcmp(optarg, "DER"))
+					input_format = FORMAT_ASN1;
+				else
+					goto synopsis;
+				break;
+
+			case 'c':  /* certificate */
+				opt_what |= DUMP_CERTIFICATE;
+				if (!input_file_type)
+					input_file_type = IN_X509;
+				break;
+
+			case 'k':  /* key */
+				opt_what |= DUMP_KEY;
+				if (!input_file_type)
+					input_file_type = IN_RSA;
+				break;
+
+			case 'l':  /* left */
+				if (!opt_what)
+					opt_what = DUMP_CERTIFICATE;
+				peer_prefix = "left";
+				break;
+
+			case 'r':  /* right */
+				if (!opt_what)
+					opt_what = DUMP_CERTIFICATE;
+				peer_prefix = "right";
+				break;
+
+			case 'C':  /* change directory */
+				if (chdir(optarg) && errno) {
+					perror(optarg);
+					error = 1;
+				}
+				break;
+
+			case 'v':  /* print version and exit */
+				printf("%s " VERSION "\n", argv[0]);
+				return 0;
+
+			case 'q':  /* quiet */
+				opt_quiet = 1;
+				break;
+
+			case 'd':  /* output in DER */
+				der_output = 1;
+				if (!strcmp(optarg, "a")) { 
+					/* ascii */
+					der_binary = 0;
+				} else if (!strcmp(optarg, "b")) {
+					der_binary = 1;
+				} else {
+					goto synopsis;
+				}
+				break;
+
+			default:
+				goto synopsis;
+		}
+	}
+	if (peer_prefix == NULL)
+		peer_prefix = "";
+
+	if (optind+1 != argc || !opt_what)
+		goto synopsis;
+
+	if (!input_file_type)
+		input_file_type = IN_X509;
+	if (!input_format)
+		input_format = FORMAT_PEM;
+
+	if (opt_quiet)
+		dup2(1,2);  /* stderr is stdout (awk hack) */
+
+	ERR_load_crypto_strings();
+	SSLeay_add_all_algorithms();
+	bio_err = BIO_new_fp (stderr, BIO_NOCLOSE);
+	
+	while (optind < argc) {
+		BIO *bio_in;
+
+		input_file = argv[optind];
+		bio_in = BIO_new_file(input_file, "rb");
+		if (!bio_in) {
+			perror(input_file);
+			error = 1;
+		} else {
+			if (input_file_type == IN_PKCS12)
+				error |= read_pkcs12_file(bio_in);
+			else if (input_file_type == IN_X509)
+				error |= read_x509_file(bio_in, input_format);
+			else if (input_file_type == IN_RSA)
+				error |= read_rsa_file(bio_in, input_format);
+			BIO_free(bio_in);
+		}
+		optind++;
+	}
+
+	BIO_free(bio_err);
+
+	return error;
+
+synopsis:
+	fprintf(stderr, "SYNOPSIS: %s --cert|--key [--left|--right] "
+	        "options file\n", argv[0]);
+	if (!opt_quiet) {
+		fprintf(stderr, "\t-c --cert\tprint certificate data\n"
+		        "\t-k --key\tprint private RSA key data\n"
+		        "\t-l --left\tleft-side parameters for ipsec.conf\n"
+		        "\t-r --right\tright-side parameters for ipsec.conf\n"
+		        "\t   --type=[x509|rsa|pkcs12]\tselect input file type\n"
+		        "\t   --format=[PEM|DER]\tselect input file format\n"
+		        "\t-C --directory=dir\tchange into dir first\n"
+		        "\t-d [ab]\tprints out the DER\n"
+			
+		        "\t-q --quiet\tsingle line error messages to stdout\n");
+	}
+	return error;
+}
+
diff -ruN freeswan-1.9.orig/utils/manual freeswan-1.9/utils/manual
--- freeswan-1.9.orig/utils/manual	Sun Dec  3 17:16:24 2000
+++ freeswan-1.9/utils/manual	Wed May 16 10:57:20 2001
@@ -12,7 +12,7 @@
 # or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 # for more details.
 #
-# RCSID $Id: manual,v 1.76 2000/12/03 22:16:24 henry Exp $
+# RCSID $Id: manual,v 1.77 2001/02/26 18:24:11 henry Exp $
 
 me='ipsec manual'
 usage="Usage:
@@ -544,7 +544,7 @@
 		print "ipsec eroute --label", q(names),
 						"--eraf inet --replace", "\\"
 		if (pass)
-			p = "%passthrough"
+			p = "%pass"
 		else {
 			if (s["type"] == "tunnel")
 				p = "tun"
diff -ruN freeswan-1.9.orig/utils/rehashcertdir freeswan-1.9/utils/rehashcertdir
--- freeswan-1.9.orig/utils/rehashcertdir	Wed Dec 31 19:00:00 1969
+++ freeswan-1.9/utils/rehashcertdir	Wed May 16 10:57:20 2001
@@ -0,0 +1,38 @@
+#!/bin/sh 
+if [ "$1" = "" ];
+then 
+  echo "Error: No directory to process."
+  echo "Usage: $0 <directory>"
+  echo
+  exit 1
+fi
+
+if [ ! -d $1 ];
+then
+  echo "Error: "$1" is not a directory."
+  echo "Usage: $0 <directory>"
+  echo
+  exit 2
+fi
+
+cd $1
+for ii in *.pem; do
+  if [ "`basename $ii`" = "crl.pem" ];
+  then
+    ln -fs $ii `openssl crl -noout -hash -in crl.pem`.crl.0
+  else
+    ln -fs $ii `openssl x509 -noout -hash -in $ii`.cert.0
+    perl -e "open(IN, \"openssl x509 -in $ii -noout -text \|\"); \
+      @IN = <IN>; \
+      foreach (@IN) { \
+        if (/IP Address:(\\d{1,3}\\.\\d{1,3}\\.\\d{1,3}\\.\\d{1,3})/) { \
+          system(\"ln -sf $ii `dirname $ii`/ip-\$1.cert.0\"); \
+        } \
+        if (/DNS:([^, ]*).*$/) { \
+          system(\"ln -sf $ii `dirname $ii`/dns-\$1.cert.0\"); \
+        } \
+      };"
+  fi
+done
+
+
diff -ruN freeswan-1.9.orig/utils/rsakeygen freeswan-1.9/utils/rsakeygen
--- freeswan-1.9.orig/utils/rsakeygen	Wed Dec 31 19:00:00 1969
+++ freeswan-1.9/utils/rsakeygen	Wed May 16 13:09:59 2001
@@ -0,0 +1,32 @@
+#!/bin/sh
+# use command line specified directory for rsakeys and publickey files,
+# otherwise use the current directory
+KEYDIR=/usr/local/lib/ipsec
+if [ $# -eq 1 ]
+then 
+  KEYDIR=$1
+fi
+
+# define variables
+KEYFILE=$KEYDIR/rsakeys
+PUBKEY=$KEYDIR/publickey
+IPSEC_SECRETS=/etc/ipsec.secrets
+
+
+# generate rsa keys 
+touch $KEYFILE
+chmod 600 $KEYFILE
+ipsec rsasigkey --random /dev/urandom 1024 > $KEYFILE
+chmod 400 $KEYFILE
+
+# extract public key to write to publickey file
+awk 'NR==3 {print $0}' $KEYFILE | cut -d= -f2 > $PUBKEY
+
+# write the rest part including private key to the ipsec.secrets file
+touch ${IPSEC_SECRETS}
+chmod 600 ${IPSEC_SECRETS}
+echo ": rsa {" > ${IPSEC_SECRETS}
+awk 'NR>3 {print $0}' $KEYFILE >> ${IPSEC_SECRETS}
+echo "	}" >> ${IPSEC_SECRETS}
+chmod 400 ${IPSEC_SECRETS}
+exit 0
diff -ruN freeswan-1.9.orig/utils/rsasigkey.c freeswan-1.9/utils/rsasigkey.c
--- freeswan-1.9.orig/utils/rsasigkey.c	Thu Feb 22 17:11:30 2001
+++ freeswan-1.9/utils/rsasigkey.c	Wed May 16 10:57:20 2001
@@ -12,7 +12,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: rsasigkey.c,v 1.14.2.2 2001/02/22 22:11:30 henry Exp $
+ * RCSID $Id: rsasigkey.c,v 1.15 2001/02/23 16:40:31 henry Exp $
  */
 
 #include <stdio.h>
diff -ruN freeswan-1.9.orig/utils/secrets.proto freeswan-1.9/utils/secrets.proto
--- freeswan-1.9.orig/utils/secrets.proto	Sun Mar 11 23:03:48 2001
+++ freeswan-1.9/utils/secrets.proto	Wed May 16 10:57:20 2001
@@ -1,4 +1,4 @@
-# RCSID $Id: secrets.proto,v 1.12.2.1 2001/03/12 04:03:48 henry Exp $
+# RCSID $Id: secrets.proto,v 1.13 2001/03/28 01:05:09 henry Exp $
 # This file holds shared secrets or RSA private keys for inter-Pluto
 # authentication.  See ipsec_pluto(8) manpage, and HTML documentation.
 
diff -ruN freeswan-1.9.orig/utils/setup freeswan-1.9/utils/setup
--- freeswan-1.9.orig/utils/setup	Wed Mar 14 18:52:41 2001
+++ freeswan-1.9/utils/setup	Wed May 16 10:57:20 2001
@@ -12,7 +12,7 @@
 # or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 # for more details.
 #
-# RCSID $Id: setup,v 1.90.2.3 2001/03/14 23:52:41 henry Exp $
+# RCSID $Id: setup,v 1.94 2001/05/08 00:48:38 henry Exp $
 #
 # ipsec         init.d script for starting and stopping
 #               the IPsec security subsystem (KLIPS and Pluto).
@@ -82,6 +82,7 @@
 subsyslock=/var/lock/subsys/ipsec
 info=/var/run/ipsec.info
 sysflags=/proc/sys/net/ipsec
+modules=/proc/modules
 # full rp_filter path is $rpfilter1/interface/$rpfilter2
 rpfilter1=/proc/sys/net/ipv4/conf
 rpfilter2=rp_filter
@@ -100,8 +101,11 @@
 	# load module if necessary
 	if test ! -f $ipsecversion
 	then
-		unset MODPATH MODULECONF	# no user overrides!
-		depmod -a >/dev/null 2>&1 && modprobe ipsec
+		if test -r $modules		# kernel does have modules
+		then
+			unset MODPATH MODULECONF	# no user overrides!
+			depmod -a >/dev/null 2>&1 && modprobe ipsec
+		fi
 		if test ! -f $ipsecversion
 		then
 			echo "Fatal error, kernel appears to lack KLIPS."
@@ -130,8 +134,8 @@
 	then
 		sysflag "$IPSECfragicmp" "fragicmp" no icmp
 		echo 1 >$sysflags/inbound_policy_check	# no debate
-		sysflag "$IPSECno_eroute_pass" "no_eroute_pass" no no_eroute_pass
-		sysflag "$IPSECopportunistic" "opportunistic" no opportunistic
+		sysflag no "no_eroute_pass" no no_eroute_pass	# obsolete parm
+		sysflag no "opportunistic" no opportunistic	# obsolete parm
 		sysflag "$IPSEChidetos" "hidetos" yes tos
 	else
 		echo "Cannot adjust kernel flags, no $sysflags directory!"
@@ -151,6 +155,26 @@
 			;;
 		esac
 	done
+
+	# set up default eroute if necessary
+	if test " $IPSECpacketdefault" = " "
+	then
+		case "$IPSECno_eroute_pass" in
+		''|no)	IPSECpacketdefault=drop	;;
+		yes)	IPSECpacketdefault=pass	;;
+		*)	echo "$me: unknown (not yes/no) no_eroute_pass value \`$IPSECno_eroute_pass'" >&2
+			IPSECpacketdefault=drop
+			;;
+		esac
+	fi
+	case "$IPSECpacketdefault" in
+	pass|reject)
+		ipsec eroute --label "packetdefault" --eraf inet \
+			--src 0/0 --dst 0/0 --said "%$IPSECpacketdefault"
+		;;
+	drop)	;;
+	*)	echo "$me: unknown packetdefault value \`$IPSECpacketdefault'" >&2 ;;
+	esac
 }
 
 # set up a system flag based on a variable
@@ -160,6 +184,17 @@
 	'')	v="$3"	;;
 	*)	v="$1"	;;
 	esac
+	if test ! -f $sysflags/$4
+	then
+		if test " $v" != " $3"
+		then
+			echo "$me: cannot implement $2=$v because" >&2
+			echo "	$sysflags/$4 does not exist" >&2
+			return 1
+		else
+			return 0	# can't set it, but it's default anyway
+		fi
+	fi
 	case "$v" in
 	yes)	echo 1 >$sysflags/$4	;;
 	no)	echo 0 >$sysflags/$4	;;
@@ -281,7 +316,7 @@
 	# searches, if needed
 	if test " $IPSECplutoload" = " %search"
 	then
-		eval `ipsec _confread --varprefix PLUTO --search auto add start`
+		eval `ipsec _confread --varprefix PLUTO --search auto add start background`
 		if test " $PLUTO_confreadstatus" != " "
 		then
 			echo "plutoload: $PLUTO_confreadstatus" | logit
@@ -508,6 +543,9 @@
 	fore)	plutogo 2>&1 | logit	;;
 	esac
 	echo "...FreeS/WAN IPsec started" | logonly
+
+	echo "Starting background tunnels..." | logit
+	$0 --startbacktunnels
 	;;
 
   stop|--stop)
@@ -531,8 +569,21 @@
 		rm -f $plutopid
 	elif kill -0 `cat $plutopid` 2>/dev/null
 	then
+	  (
+		# kill pluto in 30 secs no matter what.
+		(
+			sleep 30
+			echo "30 second timeout expired. Killing Pluto." | logit
+			kill -9 $plutopid &> /dev/null
+		) &> /dev/null &
+		killpid=$!
 		ipsec whack --shutdown | awk '$1 != "002"' | logit
 		sleep 1			# general paranoia
+		# kill the killpid if we still need to.
+		if kill -0 $killpid &> /dev/null ; then
+			kill -9 $killpid &> /dev/null
+		fi
+	  ) 2> /dev/null
 		if test -s $plutopid
 		then
 			echo "Pluto did not go away!  Killing it:" | logit
@@ -578,6 +629,26 @@
   --help)
 	echo "Usage: $me {--start|--stop|--restart}"
 	exit 0
+	;;
+ 
+  startbacktunnels|--startbacktunnels)
+	(
+	eval `ipsec _confread --varprefix PLUTO --search auto background`
+	if test " $PLUTO_confreadstatus" != " "
+	then
+		echo "$PLUTO_confreadstatus (start search) -- aborting" |
+								logit
+		exit 1
+	fi
+	IPSECplutobackground="$PLUTO_confreadnames"
+
+	(
+	for TUNNEL in $IPSECplutobackground ; 
+	do
+	  ipsec auto --up $TUNNEL 
+	done
+	) &>/dev/null 
+	) &
 	;;
 
   *)
diff -ruN freeswan-1.9.orig/utils/showhostkey freeswan-1.9/utils/showhostkey
--- freeswan-1.9.orig/utils/showhostkey	Sun Mar 11 23:03:31 2001
+++ freeswan-1.9/utils/showhostkey	Wed May 16 10:57:20 2001
@@ -12,7 +12,7 @@
 # or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 # for more details.
 #
-# RCSID $Id: showhostkey,v 1.1.2.1 2001/03/12 04:03:31 henry Exp $
+# RCSID $Id: showhostkey,v 1.2 2001/03/28 01:12:44 henry Exp $
 
 me="ipsec showhostkey"
 usage="Usage: $me [--file secrets] [--left] [--right]"
diff -ruN freeswan-1.9.orig/utils/updown.firewall freeswan-1.9/utils/updown.firewall
--- freeswan-1.9.orig/utils/updown.firewall	Wed Dec 31 19:00:00 1969
+++ freeswan-1.9/utils/updown.firewall	Wed May 16 10:57:20 2001
@@ -0,0 +1,166 @@
+#! /bin/sh
+# sample updown script for ipchains
+# Copyright (C) 2000  D. Hugh Redelmeier, Henry Spencer
+# sample updown script for iptables
+# Copyright (C) 2000  Luc Lanthier
+# 
+# This program is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the
+# Free Software Foundation; either version 2 of the License, or (at your
+# option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
+# 
+# This program is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+# for more details.
+#
+# RCSID $Id: updown.firewall,v 1.1.2.9 2001/03/27 18:44:16 lanthierl Exp $
+#
+# Modifications: Add ipchains rules specific to Netwinder OfficeServer to
+# let FreeS/WAN work with the firewall. Dacheng Tang
+
+KERNVER=`uname -r | cut -d. -f 1,2`
+
+# check interface version
+case "$PLUTO_VERSION" in
+1.0)    echo "$0: Pluto interface version 1.0 is obsolete." >&2
+        ;;
+1.1)    ;;
+*)      echo "$0: unknown interface version \`$PLUTO_VERSION'" >&2
+        exit 2
+        ;;
+esac
+
+# check parameter(s)
+case "$*" in
+'')     ;;
+*)      echo "$0: parameters unexpected" >&2
+        exit 2
+        ;;
+esac
+
+# utility functions for route manipulation
+# Meddling with this stuff should never be necessary and is most unwise.
+uproute() {
+    route add -net $PLUTO_PEER_CLIENT_NET netmask $PLUTO_PEER_CLIENT_MASK \
+      dev $PLUTO_INTERFACE gw $PLUTO_NEXT_HOP
+      st=$?
+      if test $st -ne 0
+      then
+        # route has already given its own cryptic message
+        echo "$0: \`route $1 $parms' failed" >&2
+      fi
+      return $st
+}
+
+downroute() {
+    route del -net $PLUTO_PEER_CLIENT_NET netmask $PLUTO_PEER_CLIENT_MASK \
+      dev $PLUTO_INTERFACE gw $PLUTO_NEXT_HOP 
+      st=$?
+      if test $st -ne 0
+      then
+        # route has already given its own cryptic message
+        echo "$0: \`route $1 $parms' failed" >&2
+      fi
+      return $st
+
+}
+
+# the big choice
+case "$PLUTO_VERB" in
+prepare-host|prepare-client)
+        # delete possibly-existing route (preliminary to adding a route)
+        oops="`route del -net $PLUTO_PEER_CLIENT_NET \
+                                        netmask $PLUTO_PEER_CLIENT_MASK 2>&1`"
+        status="$?"
+        if test " $oops" = " " -a " $status" != " 0"
+        then
+                oops="silent error in route command, exit status $status"
+        fi
+        case "$oops" in
+        'SIOCDELRT: No such process')
+                # This is what route (currently -- not documented!) gives
+                # for "could not find such a route".
+                status=0
+                ;;
+        esac
+        exit $status
+        ;;
+route-host|route-client)
+        # connection to this host or client being routed
+        uproute
+        ;;
+unroute-host|unroute-client)
+        # connection to this host or client being unrouted
+        downroute
+        ;;
+up-host)
+        # connection to this host coming up
+        ;;
+down-host)
+        # connection to this host going down
+        ;;
+up-client)
+  if [ "$KERNVER" = "2.2" ];
+  then
+	# add an input rule to let KLIPS decapsulated packets pass ipsec0
+	ipchains -A input -i $PLUTO_INTERFACE -j ACCEPT -p all \
+		-d $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK
+        # connection to client subnet, through forwarding firewall, coming up
+        ipchains -I forward -j ACCEPT -b \
+                -s $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK \
+                -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK
+  elif [ "$KERNVER" = "2.4" ];
+  then
+    # add an input rule to let KLIPS decapsulated packets pass ipsec0
+    iptables -A INPUT -i $PLUTO_INTERFACE -j ACCEPT \
+        -d $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK
+        # connection to client subnet, through forwarding firewall, coming up
+    iptables -I FORWARD -j ACCEPT \
+        -s $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK \
+        -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK
+    iptables -I FORWARD -j ACCEPT \
+        -s $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK \
+        -d $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK
+    if ( iptables -t nat -L -n &> /dev/null ) ; then
+      iptables -t nat -I POSTROUTING -j ACCEPT \
+        -s $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK \
+        -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK
+    fi
+  fi
+  ;;
+down-client)
+  if [ "$KERNVER" = "2.2" ];
+  then
+	# delete the input rule for the KLIPS decapsulated packets 
+	ipchains -D input -i $PLUTO_INTERFACE -j ACCEPT -p all \
+		-d $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK
+        # connection to client subnet, through forwarding firewall, going down
+        ipchains -D forward -j ACCEPT -b \
+                -s $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK \
+                -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK
+  elif [ "$KERNVER" = "2.4" ];
+  then
+    # delete the input rule for the KLIPS decapsulated packets
+    iptables -D INPUT -i $PLUTO_INTERFACE -j ACCEPT \
+        -d $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK
+        # connection to client subnet, through forwarding firewall, going down
+    iptables -D FORWARD -j ACCEPT \
+        -s $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK \
+        -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK
+    iptables -D FORWARD -j ACCEPT \
+        -s $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK \
+        -d $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK
+    if ( iptables -t nat -L -n &> /dev/null ) ; then
+      iptables -t nat -D POSTROUTING -j ACCEPT \
+        -s $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK \
+        -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK
+    fi
+  fi
+  # force a zero error code even the ipchains command(s) failed
+  echo "ok"
+  ;;
+*)      echo "$0: unknown verb \`$PLUTO_VERB' or parameter \`$1'" >&2
+        exit 1
+        ;;
+esac
diff -ruN freeswan-1.9.orig/version.c freeswan-1.9/version.c
--- freeswan-1.9.orig/version.c	Mon Feb 26 18:56:08 2001
+++ freeswan-1.9/version.c	Thu May 17 14:34:51 2001
@@ -1,2 +1,2 @@
-/* silly pointless RCSID $Id: version.c,v 1.17.2.1 2001/02/26 23:56:08 henry Exp $ */
-static const char freeswan_version[] = "1.9";
+/* silly pointless RCSID $Id: version.c,v 1.17 2000/11/30 05:02:51 henry Exp $ */
+static const char freeswan_version[] = "FreeSWAN-1.9-pkix1";
diff -ruN freeswan-1.9.orig/zlib/Makefile freeswan-1.9/zlib/Makefile
--- freeswan-1.9.orig/zlib/Makefile	Mon Jan 29 17:22:00 2001
+++ freeswan-1.9/zlib/Makefile	Wed May 16 10:57:20 2001
@@ -12,7 +12,7 @@
 # or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 # for more details.
 #
-# RCSID $Id: Makefile,v 1.2 2001/01/29 22:22:00 rgb Exp $
+# RCSID $Id: Makefile,v 1.3 2001/04/21 23:05:24 rgb Exp $
 #
 
 ifndef TOPDIR
@@ -44,19 +44,22 @@
 .S.o:
 	$(CC) -D__ASSEMBLY__ -DNO_UNDERLINE -traditional -c $< -o $*.o
 
-ifdef CONFIG_IPSEC_IPCOMP_ASM_FIXED
-ifdef CONFIG_M586
-  objs-y += match586.o
-  override CFLAGS += -DASMV
-endif
-ifdef CONFIG_M586TSC
-  objs-y += match586.o
-  override CFLAGS += -DASMV
-endif
-ifdef CONFIG_M686
-  objs-y += match686.o
-  override fCFLAGS += -DASMV
-endif
+asm-obj-$(CONFIG_M586)		+= match586.o
+asm-obj-$(CONFIG_M586TSC)	+= match586.o
+asm-obj-$(CONFIG_M586MMX)	+= match586.o
+asm-obj-$(CONFIG_M686)		+= match686.o
+asm-obj-$(CONFIG_MPENTIUMIII)	+= match686.o
+asm-obj-$(CONFIG_MPENTIUM4)	+= match686.o
+asm-obj-$(CONFIG_MK6)		+= match586.o
+asm-obj-$(CONFIG_MK7)		+= match686.o
+asm-obj-$(CONFIG_MCRUSOE)	+= match586.o
+asm-obj-$(CONFIG_MWINCHIPC6)	+= match586.o
+asm-obj-$(CONFIG_MWINCHIP2)	+= match686.o
+asm-obj-$(CONFIG_MWINCHIP3D)	+= match686.o
+
+obj-y += $(asm-obj-y)
+ifneq ($(strip $(asm-obj-y)),)
+  EXTRA_CFLAGS += -DASMV
 endif
 
 active-objs     := $(sort $(obj-y) $(obj-m))
@@ -74,6 +77,9 @@
 
 #
 # $Log: Makefile,v $
+# Revision 1.3  2001/04/21 23:05:24  rgb
+# Update asm directives for 2.4 style makefiles.
+#
 # Revision 1.2  2001/01/29 22:22:00  rgb
 # Convert to 2.4 new style with back compat.
 #
